/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var usespopup;

var gLeftTime=2;
var abURI=null;
var ioService=Components.classes["@mozilla.org/network/io-service;1"]
               .getService(Components.interfaces.nsIIOService);

var mabFiles;
var mabName;
var mabFile;
var warn=0;

var strings;

//TODO: welche Addressbcher sind auf dem Server zu finden!?
function download()
{
  usespopup=window.location=='chrome://addressbookssync/content/download.xul';

  strings = document.getElementById("strings");

  var synctype='none';
  var doc=usespopup?window.opener.document:document;
  if (doc.getElementById( "DownloadMabFile" ) && doc.getElementById( "DownloadMabFile" ).value) {
    mabFiles=new Array(doc.getElementById( "DownloadMabFile" ).value);
    doc.getElementById( "DownloadMabFile" ).value='';
    synctype='remote';
  } else {
    mabFiles=syncedAddressbooks();
    try{ synctype = pref.getCharPref( "extensions.addressbookssync.synctype" ); }
      catch(e){ synctype = 'none'; }
  }

  if (synctype=='local') {
    setTimeout(getLocalData, 0);  // need time to show the popup
  } else if (synctype=='remote') {
    abURI=getSyncURI(false);
    setTimeout(getData, 0);
  } else {
    killMe();
  }
}

function getLocalData() {
  mabFile=mabFiles.pop();
  if (!mabFile) {
    if (warn) gLeftTime=5;//a little bit longer
    killMe();
    return;
  }
  mabName=getAddressBook(mabFile).directoryProperties.description;
  var localpath=pref.getCharPref( "extensions.addressbookssync.localpath" )
  if (localpath) {
    var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    dir.initWithPath( localpath );
    if (loadMabFile(mabName, mabFile, dir))
      statustxt(mabName+': '+strings.getString('ok'), true, false);
    else
      statustxt(mabName+': '+strings.getString('failed'), true, true);
  }
  setTimeout(getLocalData, 0);
}

function getData()
{
  mabFile=mabFiles.pop();
  if (!mabFile) {
    if (warn) gLeftTime=5;//a little bit longer
    killMe();
    return;
  }
  mabName=getAddressBook(mabFile).directoryProperties.description;

  var remoteFileName = mabName+".mab";

  statustxt("download "+mabName+".", true, false);

  var mabURI=abURI+remoteFileName;
  var URI=ioService.newURI(mabURI,null,null);

  statustxt(".", false, false);

  if(gBookmarksSynchronizerDownloadService.start(URI, downloadCallback))
    statustxt(".", false, false); //"request"
  else
    downloadCallback("done",-1);
}

function downloadCallback(aStatus,aError)
{
  if(aStatus != "done" && aError==0)
    return;

  switch(aError){
  case -2:
    return;
    break;
  case 0:
    var time=gBookmarksSynchronizerDownloadService.time;    //download time
    var processtime=gBookmarksSynchronizerDownloadService.length.toString()
                      +" bytes  "+(time/1000).toString() + " sec  ";
    var start=new Date();
    statustxt(".", false, false); //"process"
    try{
      var abData=gBookmarksSynchronizerDownloadService.data;
      //Data must start with: // <!-- <mdb:mork:z v="1.4"/> --> otherwise its an HTML error page
      if (abData.substr( 0, 19 )=='// <!-- <mdb:mork:z') {
        replaceAddressBook(mabName, mabFile, abData);

        var end=new Date();
        processtime += ((end.getTime() - start.getTime())/1000).toString()+" sec";  //processing time
        statustxt(strings.getString('ok')+' '+processtime, false, false);
      } else {    //try to extract error message from <title> tag
        if(abData.match(/<title>(.+)<\/title>/i))
          statustxt(RegExp.$1, false, true);
        else
          statustxt(strings.getString('failed'), false, true);
        warn=1;
      }
      if (usespopup) getData();  // next addressbook
      else setTimeout(getData, 1000);
    } catch(e) {
      if(e && e.toString().match(/^absync\:(.+)$/))
        statustxt(RegExp.$1, false, true);
    }
    break;
  default:
    var error=errorstr(aError);
    statustxt(error, false, true);
    gLeftTime=5;
    killMe();
    break;
  }
}

function cancelDownload()
{
  gBookmarksSynchronizerDownloadService.cancel();
  killMe();
}

function killMe()
{
  if(gLeftTime>0) {
    gLeftTime--;
    setTimeout(killMe,1000);
  } else {
    statustxt('', true, false);
    if (usespopup) setTimeout(close,0);
  }
}


